## ros-humble-spinnaker-camera-driver 2.0.6

=== CMakeLists.txt ===
# -*- cmake -*-
#
# Copyright 2023 Bernd Pfrommer <bernd.pfrommer@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.5)
project(spinnaker_camera_driver)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

# the spinnaker SDK does not provide a cmake file
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

# If Spinnacker is already present, use the found version. If not, download it.
# We can't resolve this dependency using the usual rosdep means because
# the Point Grey EULA prohibits redistributing the headers or the packages which
# contains them. We work around this by downloading the archive directly from
# their website during this step in the build process.

# Spinnaker does not provide a cmake discovery mechanism so we
# provide a find script in the cmake path
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
find_package(SPINNAKER QUIET)
message(STATUS
  "Found variable: ${SPINNAKER_FOUND} at ${SPINNAKER_LIBRARIES} and ${SPINNAKER_INCLUDE_DIRS}")

set(SPINNAKER_WAS_DOWNLOADED FALSE)
if(NOT SPINNAKER_FOUND)
  message(STATUS "spinnaker not found")
  message(STATUS "libSpinnaker not found in system library path")
  include(cmake/DownloadSpinnaker.cmake)
  download_spinnaker(SPINNAKER_LIBRARIES SPINNAKER_INCLUDE_DIRS)
  set(SPINNAKER_WAS_DOWNLOADED TRUE)
else()
  message(STATUS "spinnaker SDK found installed")
endif()

message(STATUS "libSpinnaker library location: ${SPINNAKER_LIBRARIES}")
message(STATUS "libSpinnaker include location: ${SPINNAKER_INCLUDE_DIRS}")

find_package(SPINNAKER REQUIRED)

include_directories(SYSTEM
  ${SPINNAKER_INCLUDE_DIRS})

# list of all packages that use ament for export (may work for others too)

set(ROS_DEPENDENCIES
  "rclcpp"
  "rclcpp_components"
  "sensor_msgs"
  "std_msgs"
  "camera_info_manager"
  "image_transport"
  "flir_camera_msgs")


# find dependencies
find_package(ament_cmake REQUIRED)
find_package(ament_cmake_ros REQUIRED)

foreach(pkg ${ROS_DEPENDENCIES})
  find_package(${pkg} REQUIRED)
endforeach()
find_package(yaml-cpp REQUIRED)

#
# shared library for composable node
#

add_library(camera_driver SHARED
  src/camera_driver.cpp
  src/spinnaker_wrapper.cpp
  src/spinnaker_wrapper_impl.cpp
  src/image.cpp
  src/pixel_format.cpp
  src/genicam_utils.cpp
)

ament_target_dependencies(camera_driver PUBLIC ${ROS_DEPENDENCIES})
target_link_libraries(camera_driver PUBLIC Spinnaker::Spinnaker PRIVATE yaml-cpp)

target_include_directories(camera_driver
  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)
rclcpp_components_register_nodes(camera_driver "spinnaker_camera_driver::CameraDriver")

#
# the driver node uses the shared library
#
add_executable(camera_driver_node
  src/camera_driver_node.cpp)

target_link_libraries(camera_driver_node camera_driver)

target_include_directories(camera_driver_node
  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)

target_include_directories(camera_driver PRIVATE include)

# the node must go into the project specific lib directory or else
# the launch file will not find it

install(TARGETS
  camera_driver_node
  DESTINATION lib/${PROJECT_NAME}/)

# the shared library goes into the global lib dir so it can
# be used as a composable node by other projects

install(TARGETS
  camera_driver
  DESTINATION lib
)

install(DIRECTORY
  config
  DESTINATION share/${PROJECT_NAME}/
)

install(DIRECTORY
  launch
  DESTINATION share/${PROJECT_NAME}/
)

if(SPINNAKER_WAS_DOWNLOADED)
  set(SPINNAKER_BUILD_SUBDIR "opt/spinnaker/lib")
  set(SPINNAKER_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}/${SPINNAKER_BUILD_SUBDIR}")
  message(STATUS "installing spinnaker libraries from ${SPINNAKER_BUILD_DIR}")
  install(DIRECTORY  "${SPINNAKER_BUILD_DIR}" DESTINATION ${CMAKE_INSTALL_PREFIX})
endif()

if(BUILD_TESTING)
  find_package(ament_cmake REQUIRED)
  find_package(ament_cmake_copyright REQUIRED)
  find_package(ament_cmake_cppcheck REQUIRED)
  find_package(ament_cmake_cpplint REQUIRED)
  find_package(ament_cmake_flake8 REQUIRED)
  find_package(ament_cmake_lint_cmake REQUIRED)
  find_package(ament_cmake_pep257 REQUIRED)
  find_package(ament_cmake_clang_format REQUIRED)
  find_package(ament_cmake_xmllint REQUIRED)

  ament_copyright(EXCLUDE ${CMAKE_CURRENT_SOURCE_DIR}/cmake/TargetArch.cmake)
  ament_cppcheck(LANGUAGE c++)
  ament_cpplint(FILTERS "-build/include,-runtime/indentation_namespace")
  ament_flake8()
  ament_lint_cmake()
  ament_pep257()
  ament_clang_format(CONFIG_FILE .clang-format)
  ament_xmllint()
endif()

ament_package()

=== debian/changelog ===
ros-humble-spinnaker-camera-driver (2.0.6-1jammy) jammy; urgency=high

  * fix arm64 build: use correct file name when downloading spinnaker from clearpath
  * fix broken build when the Spinnaker SDK is present
  * allow building with older version (0.6) of yaml library
  * Contributors: Bernd Pfrommer

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Sat, 12 Aug 2023 04:00:00 -0000

ros-humble-spinnaker-camera-driver (2.0.5-1jammy) jammy; urgency=high

  * add ffmpeg dependency to fix build failures on ROS farm
  * switch from custom config files to standard yaml format
  * Contributors: Bernd Pfrommer

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Fri, 11 Aug 2023 04:00:00 -0000

ros-humble-spinnaker-camera-driver (2.0.4-1jammy) jammy; urgency=high

  * install spinnaker libraries in spinnaker_camera_driver dir
  * Contributors: Bernd Pfrommer

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Thu, 10 Aug 2023 04:00:00 -0000

ros-humble-spinnaker-camera-driver (2.0.3-1jammy) jammy; urgency=high

  * Hardcoding OS to jammy since it is the only one currently supported.
  * Contributors: Tony Baltovski

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Tue, 01 Aug 2023 04:00:00 -0000

ros-humble-spinnaker-camera-driver (2.0.2-1jammy) jammy; urgency=high

  * replace lsb-release with python3-distro
  * add dependencies for spinnaker download
  * Contributors: Bernd Pfrommer

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Fri, 28 Jul 2023 04:00:00 -0000

ros-humble-spinnaker-camera-driver (2.0.1-1jammy) jammy; urgency=high

  * use cmake find_program to detect lsb_release
  * Contributors: Bernd Pfrommer

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Mon, 24 Jul 2023 04:00:00 -0000

ros-humble-spinnaker-camera-driver (2.0.0-1jammy) jammy; urgency=high

  * Merge pull request #113 <https://github.com/ros-drivers/flir_camera_driver/issues/113> from berndpfrommer/humble-devel-new
    new driver for ROS2
  * added spinnaker_camera_driver package
  * deleted spinnaker ros2 driver, to be replaced by new version
  * Contributors: Bernd Pfrommer, Tony Baltovski

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Thu, 20 Jul 2023 04:00:00 -0000

=== debian/control ===
Source: ros-humble-spinnaker-camera-driver
Section: misc
Priority: optional
Maintainer: Bernd Pfrommer <bernd.pfrommer@gmail.com>
Build-Depends: debhelper (>= 9.0.0), curl, dpkg, ffmpeg, libavcodec-dev, libavformat-dev, libavutil-dev, libcurl4-openssl-dev, libswscale-dev, libusb-1.0-0-dev, libyaml-cpp-dev, python3-distro, ros-humble-ament-cmake, ros-humble-ament-cmake-clang-format <!nocheck>, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-camera-info-manager, ros-humble-flir-camera-msgs, ros-humble-image-transport, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-sensor-msgs, ros-humble-std-msgs, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-spinnaker-camera-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ffmpeg, libavcodec-dev, libavformat-dev, libavutil-dev, libswscale-dev, libusb-1.0-0-dev, libyaml-cpp-dev, ros-humble-camera-info-manager, ros-humble-flir-camera-msgs, ros-humble-image-transport, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-sensor-msgs, ros-humble-std-msgs, ros-humble-ros-workspace
Description: ROS2 driver for flir spinnaker sdk

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-spinnaker-camera-driver//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install

## ros-humble-spinnaker-camera-driver 2.1.17

=== debian/changelog ===
ros-humble-spinnaker-camera-driver (2.1.17-1bookworm) bookworm; urgency=high

  * fix broken composable node by installing in correct location
  * Add FLIR-AX5 Camera (#176 <https://github.com/ros-drivers/flir_camera_driver/issues/176>)
  * Contributors: Bernd Pfrommer, anonymousarmadillo100

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Fri, 17 May 2024 16:00:00 -0000

ros-humble-spinnaker-camera-driver (2.1.16-1bookworm) bookworm; urgency=high

  * add option to disable external control (default!)
  * updated docs for sync driver, switch to RST
  * widened the ExposureController interface
  * fix build errors on rolling/noble
  * added blacklevel and whitebalance support for blackfly
  * use proper name for camerainfo when using sync driver
  * Contributors: Bernd Pfrommer

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Fri, 19 Apr 2024 16:00:00 -0000

ros-humble-spinnaker-camera-driver (2.1.15-1bookworm) bookworm; urgency=high

  * fixes to compile on focal/galactic
  * Oryx parameter file
  * support for command nodes
  * remove more spinnaker imports, make spinnaker private
  * added blackfly GigE configuration file
  * track incomplete frames
  * fixed licensing documentation
  * Contributors: Bernd Pfrommer, Sir-Photch

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Wed, 27 Mar 2024 16:00:00 -0000

ros-humble-spinnaker-camera-driver (2.1.14-1bookworm) bookworm; urgency=high

  * make spinnaker dependency private for sync driver build
  * Contributors: Bernd Pfrommer

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Thu, 21 Mar 2024 16:00:00 -0000

ros-humble-spinnaker-camera-driver (2.1.13-1bookworm) bookworm; urgency=high

  * added blackfly GigE configuration file
  * track incomplete frames
  * fixed licensing documentation
  * provision camera driver for exposure control
  * fixed bugs discovered when running on GigE cams
  * avoid searching ROS path for library
  * Contributors: Bernd Pfrommer

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Tue, 12 Mar 2024 16:00:00 -0000

ros-humble-spinnaker-camera-driver (2.1.11-1bookworm) bookworm; urgency=high

  * Added connect_while_subscribed feature
  * Added binning parameter
  * Export library and refactor for synchronized driver support
  * fixed stereo launch file serial number bug
  * Contributors: Bernd Pfrommer, Luis Camero, buckleytoby

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Thu, 22 Feb 2024 16:00:00 -0000

ros-humble-spinnaker-camera-driver (2.0.8-1bookworm) bookworm; urgency=high

  * Added linux_setup_flir script instructions to Readme
  * Add newline echo before Done
  * Rename script to remove extension
  * Ask permission for usb change and don't limit detection to 1000
  * Ask about usergroup and give feedback
  * Added linux pc setup script
  * fix python formatting to satisfy linter
  * fix formatting of BSD license to satisfy linter
  * Contributors: Bernd Pfrommer, Hilary Luo

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Mon, 13 Nov 2023 16:00:00 -0000

ros-humble-spinnaker-camera-driver (2.0.7-1bookworm) bookworm; urgency=high

  * Restricted the device permissions
  * Added Teledyne to udev as requested
  * Added udev rule
  * Contributors: Hilary Luo

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Mon, 02 Oct 2023 16:00:00 -0000

ros-humble-spinnaker-camera-driver (2.0.6-1bookworm) bookworm; urgency=high

  * fix arm64 build: use correct file name when downloading spinnaker from clearpath
  * fix broken build when the Spinnaker SDK is present
  * allow building with older version (0.6) of yaml library
  * Contributors: Bernd Pfrommer

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Fri, 11 Aug 2023 16:00:00 -0000

ros-humble-spinnaker-camera-driver (2.0.5-1bookworm) bookworm; urgency=high

  * add ffmpeg dependency to fix build failures on ROS farm
  * switch from custom config files to standard yaml format
  * Contributors: Bernd Pfrommer

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Thu, 10 Aug 2023 16:00:00 -0000

ros-humble-spinnaker-camera-driver (2.0.4-1bookworm) bookworm; urgency=high

  * install spinnaker libraries in spinnaker_camera_driver dir
  * Contributors: Bernd Pfrommer

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Wed, 09 Aug 2023 16:00:00 -0000

ros-humble-spinnaker-camera-driver (2.0.3-1bookworm) bookworm; urgency=high

  * Hardcoding OS to jammy since it is the only one currently supported.
  * Contributors: Tony Baltovski

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Mon, 31 Jul 2023 16:00:00 -0000

ros-humble-spinnaker-camera-driver (2.0.2-1bookworm) bookworm; urgency=high

  * replace lsb-release with python3-distro
  * add dependencies for spinnaker download
  * Contributors: Bernd Pfrommer

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Thu, 27 Jul 2023 16:00:00 -0000

ros-humble-spinnaker-camera-driver (2.0.1-1bookworm) bookworm; urgency=high

  * use cmake find_program to detect lsb_release
  * Contributors: Bernd Pfrommer

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Sun, 23 Jul 2023 16:00:00 -0000

ros-humble-spinnaker-camera-driver (2.0.0-1bookworm) bookworm; urgency=high

  * Merge pull request #113 <https://github.com/ros-drivers/flir_camera_driver/issues/113> from berndpfrommer/humble-devel-new
    new driver for ROS2
  * added spinnaker_camera_driver package
  * deleted spinnaker ros2 driver, to be replaced by new version
  * Contributors: Bernd Pfrommer, Tony Baltovski

 -- Bernd Pfrommer <bernd.pfrommer@gmail.com>  Wed, 19 Jul 2023 16:00:00 -0000

=== debian/control ===
Source: ros-humble-spinnaker-camera-driver
Section: misc
Priority: optional
Maintainer: Bernd Pfrommer <bernd.pfrommer@gmail.com>
Build-Depends: debhelper (>= 9.0.0), curl, dpkg, ffmpeg, libavcodec-dev, libavformat-dev, libavutil-dev, libcurl4-openssl-dev, libswscale-dev, libusb-1.0-0-dev, libyaml-cpp-dev, python3-distro, ros-humble-ament-cmake, ros-humble-ament-cmake-clang-format <!nocheck>, ros-humble-ament-cmake-ros, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-camera-info-manager, ros-humble-flir-camera-msgs, ros-humble-image-transport, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-sensor-msgs, ros-humble-std-msgs, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-spinnaker-camera-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ffmpeg, libavcodec-dev, libavformat-dev, libavutil-dev, libswscale-dev, libusb-1.0-0-dev, libyaml-cpp-dev, ros-humble-camera-info-manager, ros-humble-flir-camera-msgs, ros-humble-image-transport, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-sensor-msgs, ros-humble-std-msgs, ros-humble-ros-workspace
Description: ROS2 driver for flir spinnaker sdk

=== debian/rules ===
--- 
+++ 
@@ -57,7 +57,7 @@
 	# in the install tree and source it.  It will set things like
 	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
-	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-spinnaker-camera-driver//opt/ros/humble/lib/
+	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-spinnaker-camera-driver//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-spinnaker-camera-driver//opt/ros/humble/opt/spinnaker_camera_driver/lib/
 
 override_dh_auto_install:
 	# In case we're installing to a non-standard location, look for a setup.sh
